// Cheater!
freeslot("TOL_MINESWEEPER")

// GAMETYPE //
G_AddGametype({
	name = "Minesweeper",
	identifier = "Minesweeper",
	rules = GTR_BOTS|GTR_CLOSERPLAYERS|GTR_NOCUPSELECT|GTR_NOPOSITION|GTR_SPHERES,
	typeoflevel = TOL_MINESWEEPER,
	intermissiontype = int_scoreortimeattack,
	speed = 1,
})

local coolmo = nil
local lookingforatag = -1

addHook("MapLoad", function()
	// Checks for replay. If it is, set replaymoment in ACS.
	if not replayplayback then return end
	if not mapheaderinfo[gamemap].minesweeper then return end
	lookingforatag = 70
	coolmo = nil
end)

// nihahaha
addHook("MobjThinker", function(mo)
	--if netgame then return end
	if lookingforatag == -1 then return end
	-- This works. Apparently.
	if mo.tid == lookingforatag then
		mo.tracer = coolmo
		// UNDOCUMENTED FEATURE: 
		// ball switches have a way to defer their associated action
		mo.extravalue2 = 1
		lookingforatag = -1
	end
end, MT_BALLSWITCH_BALL)

COM_AddCommand("minesweep_end", function(player)
	lookingforatag = 69
end)

addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.valid) then return end
	--if gametype == GT_MINESWEEPER then
	if mapheaderinfo[gamemap].minesweeper then
		--print(player.exiting)
		if not (player.cmd.buttons & (1<<7)) then
			player.minesweepbutan = false
		end
		if (player.cmd.buttons & (1<<7)) and not player.minesweepbutan then
			// print("woop")
			coolmo = player.mo
			if player.instawhipcharge then
				lookingforatag = 66
			else
				lookingforatag = 65
			end
			player.minesweepbutan = true
		end
	end
end)

-- Function for spawning the goalpost wherever it is called.
-- This is pretty much ported from the source code.
-- This was entirely translated to lua by JugadorXEI. (Thank you so much, genuinely.)
local function P_SetupSignObject(sign, pmo, signType)
    local cur = sign
    local prev = nil

    -- Setup the sign itself
    sign.scale = 5 * sign.scale / 2 -- 2.5x
    sign.destscale = sign.scale
    sign.target = pmo
    sign.state = S_SIGN_POLE

    sign.movefactor = sign.z
    sign.z = $ + (576*sign.scale) * P_MobjFlip(sign)
    sign.old_z = sign.z -- interp hijack
    sign.movecount = 1
    sign.extravalue1 = AngleFixed(sign.angle) >> FRACBITS

    -- Setup the overlay pieces
    -- Front
    cur.hnext = P_SpawnMobjFromMobj(sign, 0, 0, 0, MT_SIGN_PIECE)
    cur.hnext.target = sign
    cur.hnext.state = S_SIGN_FACE
    cur.hnext.extravalue1 = 6
    cur.hnext.extravalue2 = 0

    prev = cur
    cur = cur.hnext
    cur.hprev = prev

    -- Player icon
    cur.hnext = P_SpawnMobjFromMobj(sign, 0, 0, 0, MT_SIGN_PIECE)
    cur.hnext.target = sign
    cur.hnext.skin = pmo.skin
    if signType == 4 then
        cur.hnext.state = S_SIGN_ERROR
    else 
        cur.hnext.state = S_KART_SIGN
    end
    
    cur.hnext.extravalue1 = 7
    cur.hnext.extravalue2 = 0

    prev = cur
    cur = cur.hnext
    cur.hprev = prev

    -- Back
    cur.hnext = P_SpawnMobjFromMobj(sign, 0, 0, 0, MT_SIGN_PIECE)
    cur.hnext.target = sign
    cur.hnext.state = S_SIGN_BACK
    cur.hnext.extravalue1 = 6
    cur.hnext.extravalue2 = 2

    prev = cur
    cur = cur.hnext
    cur.hprev = prev

    -- Sides
    cur.hnext = P_SpawnMobjFromMobj(sign, 0, 0, 0, MT_SIGN_PIECE)
    cur.hnext.target = sign
    cur.hnext.state = S_SIGN_SIDE
    cur.hnext.extravalue1 = 30
    cur.hnext.extravalue2 = 1

    prev = cur
    cur = cur.hnext
    cur.hprev = prev

    cur.hnext = P_SpawnMobjFromMobj(sign, 0, 0, 0, MT_SIGN_PIECE)
    cur.hnext.target = sign
    cur.hnext.state = S_SIGN_SIDE
    cur.hnext.extravalue1 = 30
    cur.hnext.extravalue2 = 3

    prev = cur
    cur = cur.hnext
    cur.hprev = prev
end

addHook("SpecialExecute", function(ac, args)
	for a in players.iterate do
		if not (a.mo and a.mo.valid) then continue end
		P_DoPlayerExit(a, 0)
		local pMo = a.mo
		local sign = P_SpawnMobj(pMo.x, pMo.y, pMo.floorz, MT_SIGN)
		
		sign.angle = pMo.angle + ANGLE_180
		sign.cvmem = 2
		P_SetupSignObject(sign, pMo, 2)
	end
end, "MINESWEEPEND")